%global serial 6
%global commitid 5e08292e8c8a2071c91ac9e547ccbf2c420e7a06

%define aprver 1
%define soversion 0.7.0

%{?scl:%scl_package apr}
%{!?scl:%global pkg_name %{name}}

%global _performance_build 1
# Drop pkgconfig provide
%global __provides_exclude_from ^%{_libdir}/.*$
%global __provides_exclude_from ^%{_libdir}/pkgconfig/.*$
%global __requires_exclude_from ^%{_libdir}/pkgconfig/.*$

%define scldir /opt/rh/jbcs-httpd24/root

Summary: Apache Portable Runtime library
Name:  %{?scl_prefix}apr
Version: 1.7.0
Release: %{serial}%{?dist}
# ASL 2.0: everything
# ISC: network_io/apr-1.4.6/network_io/unix/inet_?to?.c
# BSD with advertising: strings/apr_snprintf.c, strings/apr_fnmatch.c,
#                   include/apr_fnmatch.h, misc/unix/getopt.c,
#                   file_io/unix/mktemp.c, strings/apr_strings.c
# BSD (3-clause): strings/apr_strnatcmp.c, include/apr_strings.h
License: ASL 2.0 and BSD with advertising and ISC and BSD
Group: System Environment/Libraries
URL: http://apr.apache.org/
Source0: apr-%{commitid}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-buildroot
BuildRequires: gcc, autoconf, libtool, libuuid-devel, python3
BuildRequires: make

%{?scl:Requires:%scl_runtime}

%description
The mission of the Apache Portable Runtime (APR) is to provide a
free library of C data structures and routines, forming a system
portability layer to as many operating systems as possible,
including Unices, MS Win32, BeOS and OS/2.

%package devel
Group: Development/Libraries
Summary: APR library development kit
Conflicts: subversion-devel < 0.20.1-2
Requires:  %{?scl_prefix}apr = %{version}-%{release}, pkgconfig

%description devel
This package provides the support files which can be used to 
build applications using the APR library.  The mission of the
Apache Portable Runtime (APR) is to provide a free library of 
C data structures and routines.

%package zip
Summary: Standalone apr zip file distribution

%description zip
Standalone zip distribution of apr

%prep
%setup -q -n apr-%{commitid}

%build
# regenerate configure script etc.
./buildconf

# Forcibly prevent detection of shm_open (which then picks up but
# does not use -lrt).
export ac_cv_search_shm_open=no

# Rewrite release number
sed -i "s;\@apr_release_version\@;-%{serial};g" include/apr_version.h

export LDFLAGS="-Wl,-rpath=%{_libdir} -Wl,-z,relro,-z,now"
export CFLAGS="-fPIC -g"

%configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --includedir=%{_includedir}/apr-%{aprver} \
    --with-installbuilddir=%{_libdir}/apr-%{aprver}/build \
    --with-devrandom=/dev/urandom \
    --disable-static \
    --disable-sctp

make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

# add missing files.
install -m 755 build/find_apr.m4 $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/apr_common.m4 $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/gen-build.py $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/install.sh $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/config.guess $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/config.sub $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/get-version.sh $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
install -m 755 build/PrintPath $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build
mkdir   -p $RPM_BUILD_ROOT%{_libdir}/apr-1/include
install -m 644 include/apr_version.h $RPM_BUILD_ROOT%{_libdir}/apr-1/include
install -d -m 755 $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev

# Additionally packaged (see https://bugzilla.redhat.com/1669589) --
sed -i '1s,/.*,/usr/bin/python3,' build/gen-build.py
install -m 755 build/gen-build.py $RPM_BUILD_ROOT%{_libdir}/apr-%{aprver}/build

# Trim exported dependecies
sed -ri '/^dependency_libs/{s,-l(uuid|crypt) ,,g}' \
      $RPM_BUILD_ROOT%{_libdir}/libapr*.la
sed -ri '/^LIBS=/{s,-l(uuid|crypt) ,,g;s/  */ /g}' \
      $RPM_BUILD_ROOT%{_bindir}/apr-%{aprver}-config
sed -ri '/^Libs/{s,-l(uuid|crypt) ,,g}' \
      $RPM_BUILD_ROOT%{_libdir}/pkgconfig/apr-%{aprver}.pc


# Unpackaged files:
rm -f $RPM_BUILD_ROOT%{_libdir}/apr.exp \
      $RPM_BUILD_ROOT%{_libdir}/libapr-*.a


%check

%ifarch x86_64
  make check
%endif

#Create a temporary directory for zip creation
mkdir -p $RPM_BUILD_ROOT/temp/jbcs-apr-%{version}/lib64

pushd $RPM_BUILD_ROOT
cp -pr .%{_libdir}/libapr-%{aprver}*.so* $RPM_BUILD_ROOT/temp/jbcs-apr-%{version}/lib64
mkdir -p temp/jbcs-apr-%{version}/share/doc/%{name}-%{version}
pushd %{_builddir}/apr-%{commitid}
cp CHANGES LICENSE NOTICE $RPM_BUILD_ROOT/temp/jbcs-apr-%{version}/share/doc/%{name}-%{version}
popd
popd

pushd $RPM_BUILD_ROOT/temp/
zip -q -r -y %{name}-%{version}-RHEL%{?rhel}-%{_arch}.zip .
install -p -m 644 %{name}-%{version}-RHEL%{?rhel}-%{_arch}.zip $RPM_BUILD_ROOT%{_javadir}/jbossas-fordev
rm -f *.zip
popd
rm -rf $RPM_BUILD_ROOT/temp/jbcs-apr-%{version}

%files
%doc CHANGES LICENSE NOTICE README*
%{_libdir}/libapr-%{aprver}.so.*
# JBCS-533
%{_libdir}/libapr-%{aprver}*.so

%files devel
%doc docs/APRDesign.html docs/canonical_filenames.html
%doc docs/incomplete_types docs/non_apr_programs
%{_bindir}/apr-%{aprver}-config
%{_libdir}/libapr-%{aprver}.*a
%{_libdir}/libapr-%{aprver}.so
%{_libdir}/pkgconfig/*.pc
%dir %{_libdir}/apr-%{aprver}
%dir %{_libdir}/apr-%{aprver}/build
%{_libdir}/apr-%{aprver}/build/*
%dir %{_includedir}/apr-%{aprver}
%{_includedir}/apr-%{aprver}/*.h
%dir %{_libdir}/apr-%{aprver}/include
%{_libdir}/apr-%{aprver}/include/*

%files zip
%{_javadir}/jbossas-fordev/%{name}-%{version}-RHEL%{?rhel}-%{_arch}.zip

%changelog
* Fri Mar 26 2022 Mladen Turk <mturk@redhat.com> - 1.7.0-6
- Fix apr-config so it can be used by jws/tomcat-native

* Thu Feb 10 2022 Mladen Turk <mturk@redhat.com> - 1.7.0-5
- Fix build flags

* Fri Feb 04 2022 Mladen Turk <mturk@redhat.com> - 1.7.0-4
- Add .m4 file to build directory

* Fri Feb 04 2022 Mladen Turk <mturk@redhat.com> - 1.7.0-3
- Add --prefix and --libdir to configure

* Thu Feb 03 2022 Mladen Turk <mturk@redhat.com> - 1.7.0-2
- Filter out provides and requires

* Wed Jan 26 2022 Mladen Turk <mturk@redhat.com> - 1.7.0-1
- Upgrade to apr-1.7.0


